#ifndef OROCOS_PLANT_COMPONENT_HPP
#define OROCOS_PLANT_COMPONENT_HPP

#include <rtt/RTT.hpp>
#include <rtt/Component.hpp>
#include <iostream>

using namespace RTT;
using namespace std;

class Plant: public RTT::TaskContext {
	// Data Ports
	OutputPort<double> position;
	OutputPort<double> velocity;
	InputPort<double> setpoints;

	os::TimeService::ticks stamp;

	// Internal state variables
	double pos, vel;

public:
	Plant(string const &name);

private:
	bool configureHook();
	bool startHook();
	void updateHook();
	void stopHook();
	void cleanupHook();

};

#endif
